From d9b29cc32779006d91792f645d6d54f9aee9e5ea Mon Sep 17 00:00:00 2001
From: Jiajin Cui <cuijiajin@uniontech.com>
Date: Thu, 7 Jan 2021 10:32:30 +0800
Subject: [PATCH] user32: Make text warp on display.

In the official document of microsoft, uiLengthDrawn param Receives the number of characters processed by DrawTextEx, including white-space characters.

Signed-off-by: Jiajin Cui <cuijiajin@uniontech.com>
---
 dlls/user32/text.c | 5 +++--
 1 file changed, 3 insertions(+), 2 deletions(-)

diff --git a/dlls/user32/text.c b/dlls/user32/text.c
index dd9d711cd48..9c8833c22c7 100644
--- a/dlls/user32/text.c
+++ b/dlls/user32/text.c
@@ -987,6 +987,9 @@ INT WINAPI DrawTextExW( HDC hdc, LPWSTR str, INT i_count,
 	    else if (flags & DT_BOTTOM) y = rect->bottom - size.cy;
         }
 
+    if (dtp)
+        dtp->uiLengthDrawn += len;
+
 	if (!(flags & DT_CALCRECT))
 	{
             const WCHAR *str = line;
@@ -1046,8 +1049,6 @@ INT WINAPI DrawTextExW( HDC hdc, LPWSTR str, INT i_count,
 	    y -= lh;
         else
 	    y += lh;
-        if (dtp)
-            dtp->uiLengthDrawn += len;
     }
     while (strPtr && !last_line);
 
-- 
2.20.1

